/***************************************************************************
                          kmol.cpp  -  description
                             -------------------
    begin                : Sat Feb 23 01:25:08 PST 2002
    copyright            : (C) 2002 by Tomislav Gountchev
    email                : tomi@idiom.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for QT
#include <qdir.h>
#include <qprinter.h>
#include <qpainter.h>

// include files for KDE
#include <kiconloader.h>
#include <kmessagebox.h>
#include <kfiledialog.h>
#include <kmenubar.h>
#include <kstatusbar.h>
#include <klocale.h>
#include <kconfig.h>
#include <kpopupmenu.h>
#include <kstdaction.h>

// application specific includes
#include "kmol.h"
#include "kmolwidget.h"

#define ID_STATUS_MSG 1

KMol::KMol(QWidget* parent, const char* name):KMainWindow(0, name)
{
  config=kapp->config();
  initView();
  initActions();
  readOptions();
}

KMol::~KMol()
{

}

void KMol::initActions()
{
  KPopupMenu* p = new KPopupMenu;
  KAction* fileQuit = KStdAction::quit(this, SLOT(quit()), actionCollection());
  fileQuit->plug(p);
//  p->insertItem(i18n("&Quit"), this, SLOT(quit()));
  menuBar()->insertItem(i18n("&File"), p);
  p = new KPopupMenu;
  p->insertItem(i18n("&Define..."), view, SLOT(callEditor()));
  menuBar()->insertItem(i18n("&Edit"), p);
  menuBar()->insertSeparator();
  menuBar()->insertItem( i18n("&Help"), helpMenu(NULL, FALSE) );
}


void KMol::initView()
{ 
//  setMaximumSize(220, 300);
  view = new KMolWidget(this);
  setCentralWidget(view);	
}

void KMol::saveOptions()
{	
  config->setGroup("General Options");
  config->writeEntry("Geometry", size());
}


void KMol::readOptions()
{
	
  config->setGroup("General Options");
  QSize size=config->readSizeEntry("Geometry");
  if(!size.isEmpty())
  {
    resize(size);
  }
}


void KMol::quit()
{
   KApplication::kApplication()->quit();
}

bool KMol::queryExit()
{
  saveOptions();
  return true;
}
