/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sat Feb 23 01:25:08 PST 2002
    copyright            : (C) 2002 by Tomislav Gountchev
    email                : tomi@idiom.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

#include "kmol.h"
#include "kmolcalc.h"
#include "kmolelements.h"
#include <stdio.h>

static const char *description =
	I18N_NOOP("Molecular Weight Calculator");	
	
static KCmdLineOptions options[] =
{
  { "+[formula]", I18N_NOOP("formula to process"), 0 },
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main(int argc, char *argv[])
{

	KAboutData aboutData( "kmol", I18N_NOOP("KMol"),
		VERSION, description, KAboutData::License_GPL,
		"(c) 2002, Tomislav Gountchev", 0, 0, "tomi@idiom.com");
	aboutData.addAuthor("Tomislav Gountchev",0, "tomi@idiom.com");
        aboutData.addCredit("Carsten Niehaus",
	    I18N_NOOP("Porting to KDE3 and QGridLayout"), "cniehaus@gmx.de");
	KCmdLineArgs::init( argc, argv, &aboutData );
	KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

  KApplication app;
 
  if (app.isRestored())
  {
    RESTORE(KMol);
  }
  else
  {
    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
			
	if (args->count())
    {
		KMolCalc* kmolcalc = new KMolCalc;
	  	double w = 0;
	  	for (int i = 0; i < args->count(); i++) {
	    	QString errors(kmolcalc->readFormula(QString(args->arg(i))));
	    	QTextOStream str(stdout);
	    	if (errors == "OK" && (w = kmolcalc->getWeight()) > 0) {
	    		str << args->arg(i) << ":   " << i18n("Mw") << " = " << w << ", ";
	    		str << kmolcalc->getEmpFormula().data() << "\n\n";
	    		str << kmolcalc->getEA().data() << "\n\n\n";
	    	} else
	      		str << " ??? " << i18n("ERROR: ") << errors.data() << "\n\n";
	  	}
		return 0;
	}
	else
	{
		
	    KMol *kmol = new KMol();
	    kmol->show();
	}
	args->clear();
  	}
  return app.exec();
}  
